﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Collections.Specialized;
using System.Collections.Generic;
using System.Collections;
using System.Threading;
using System.Linq;
using System;

namespace MYDATA
{
  public class CAlias : INotifyPropertyChanged
  {
    string g_name;
    bool g_showInOrgChart;
    CViewModel g_viewModel;

    public CAlias( string name, CViewModel viewModel, bool showInOrgChart )
    {
      this.Name = name;
      g_viewModel = viewModel;
      ShowInOrgChart = showInOrgChart;
    }

    public string Name
    {
      get { return g_name; }
      set
      {
        if (value != g_name)
        {
          g_name = value;
          OnPropertyChanged( "Name" );
        }
      }
    }

    public bool ShowInOrgChart
    {
      get { return g_showInOrgChart; }
      set
      {
        if (value != g_showInOrgChart)
        {
          g_showInOrgChart = value;

          if (value)
            g_viewModel.AddToOrgChart( this );
          else
            g_viewModel.RemoveFromOrgChart( this );
          OnPropertyChanged( "ShowInOrgChart" );
        }
      }
    }

    public event PropertyChangedEventHandler PropertyChanged;

    private void OnPropertyChanged( string propertyName )
    {
      if (PropertyChanged != null)
        PropertyChanged( this, new PropertyChangedEventArgs( propertyName ) );
    }
  }



  public class CViewModel
  {
    public ObservableCollection<CAlias> AliasInOrgChart { get { return g_aliasInOrgChartMirror; } }
    public ObservableCollection<CAlias> AllAliasList { get { return g_allAliasListMirror; } }

    ObservableCollection<CAlias> g_allAliasListMirror { get; set; }
    ObservableCollection<CAlias> g_aliasInOrgChartMirror { get; set; }

    public CViewModel()
    {
      g_allAliasListMirror = new ObservableCollection<CAlias>();
      g_aliasInOrgChartMirror = new ObservableCollection<CAlias>();


      LoadData();
    }

    public void LoadData()
    {
      g_allAliasListMirror.Clear();
      g_aliasInOrgChartMirror.Clear();

      g_allAliasListMirror.Add( new CAlias( "VD", this, true ) );
      g_allAliasListMirror.Add( new CAlias( "Coder1", this, true ) );
      g_allAliasListMirror.Add( new CAlias( "Coder2", this, true ) );
      g_allAliasListMirror.Add( new CAlias( "Support", this, true ) );
    }

    public void AddToOrgChart( CAlias alias )
    {
      g_aliasInOrgChartMirror.Add( alias );
    }

    public void RemoveFromOrgChart( CAlias alias )
    {
      g_aliasInOrgChartMirror.Remove( alias );
    }

  }

  


}
